<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.appointment.dao.ibatis.AppointmentPersonDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="AppointmentPersonEntity" id="AppointmentPersonEntity-Map">
        <id  property="id" column="id" />
        <result property="siteId" column="siteId" />
        <result property="siteName" column="siteName" />
        <result property="personId" column="personId" />
        <result property="name" column="name" />
        <result property="contactInfo" column="contactInfo" />
        <result property="idCard" column="idCard" />
        <result property="bussinessId" column="bussinessId" />
        <result property="bussinessName" column="bussinessName" />
        <result property="appontmentNumber" column="appontmentNumber" />
        <result property="appointmentStartTime" column="appointmentStartTime" />
        <result property="appointmentEndTime" column="appointmentEndTime" />
        <result property="createUserId" column="createUserId" />
        <result property="createTime" column="createTime" />
        <result property="updateUserId" column="updateUserId" />
        <result property="updateTime" column="updateTime" />

    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                a.id,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('siteId') or colPickMode == 1 and data.containsKey('siteId')))">
                a.siteId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('siteName') or colPickMode == 1 and data.containsKey('siteName')))">
                a.siteName,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('personId') or colPickMode == 1 and data.containsKey('personId')))">
                a.personId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('name') or colPickMode == 1 and data.containsKey('name')))">
                a.name,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('contactInfo') or colPickMode == 1 and data.containsKey('contactInfo')))">
                a.contactInfo,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('idCard') or colPickMode == 1 and data.containsKey('idCard')))">
                a.idCard,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('bussinessId') or colPickMode == 1 and data.containsKey('bussinessId')))">
                a.bussinessId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('bussinessName') or colPickMode == 1 and data.containsKey('bussinessName')))">
                a.bussinessName,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('appontmentNumber') or colPickMode == 1 and data.containsKey('appontmentNumber')))">
                a.appontmentNumber,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('appointmentStartTime') or colPickMode == 1 and data.containsKey('appointmentStartTime')))">
                a.appointmentStartTime,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('appointmentEndTime') or colPickMode == 1 and data.containsKey('appointmentEndTime')))">
                a.appointmentEndTime,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createUserId') or colPickMode == 1 and data.containsKey('createUserId')))">
                a.createUserId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                a.createTime,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUserId') or colPickMode == 1 and data.containsKey('updateUserId')))">
                a.updateUserId,
            </if>
            <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                a.updateTime,
            </if>
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="AppointmentPersonEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_appointment_person
        (siteId,siteName,personId,name,contactInfo,idCard,bussinessId,bussinessName,appontmentNumber,appointmentStartTime,appointmentEndTime,createUserId,createTime,updateUserId,updateTime)
        VALUES
        (#{siteId},#{siteName},#{personId},#{name},#{contactInfo},#{idCard},#{bussinessId},#{bussinessName},#{appontmentNumber},#{appointmentStartTime},#{appointmentEndTime},#{createUserId},#{createTime},#{updateUserId},#{updateTime})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_appointment_person
        (siteId,siteName,personId,name,contactInfo,idCard,bussinessId,bussinessName,appontmentNumber,appointmentStartTime,appointmentEndTime,createUserId,createTime,updateUserId,updateTime)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.siteId},#{item.siteName},#{item.personId},#{item.name},#{item.contactInfo},#{item.idCard},#{item.bussinessId},#{item.bussinessName},#{item.appontmentNumber},#{item.appointmentStartTime},#{item.appointmentEndTime},#{item.createUserId},#{item.createTime},#{item.updateUserId},#{item.updateTime})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_appointment_person as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('siteId')) or (colPickMode==1 and !data.containsKey('siteId'))">
                a.siteId=#{data.siteId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('siteIdIncrement')) or (colPickMode==1 and !data.containsKey('siteIdIncrement'))">
                a.siteId=ifnull(a.siteId,0) + #{data.siteIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('siteName')) or (colPickMode==1 and !data.containsKey('siteName'))">
                a.siteName=#{data.siteName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('personId')) or (colPickMode==1 and !data.containsKey('personId'))">
                a.personId=#{data.personId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('personIdIncrement')) or (colPickMode==1 and !data.containsKey('personIdIncrement'))">
                a.personId=ifnull(a.personId,0) + #{data.personIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('name')) or (colPickMode==1 and !data.containsKey('name'))">
                a.name=#{data.name},
            </if>
            <if test="(colPickMode==0 and data.containsKey('contactInfo')) or (colPickMode==1 and !data.containsKey('contactInfo'))">
                a.contactInfo=#{data.contactInfo},
            </if>
            <if test="(colPickMode==0 and data.containsKey('idCard')) or (colPickMode==1 and !data.containsKey('idCard'))">
                a.idCard=#{data.idCard},
            </if>
            <if test="(colPickMode==0 and data.containsKey('bussinessId')) or (colPickMode==1 and !data.containsKey('bussinessId'))">
                a.bussinessId=#{data.bussinessId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('bussinessIdIncrement')) or (colPickMode==1 and !data.containsKey('bussinessIdIncrement'))">
                a.bussinessId=ifnull(a.bussinessId,0) + #{data.bussinessIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('bussinessName')) or (colPickMode==1 and !data.containsKey('bussinessName'))">
                a.bussinessName=#{data.bussinessName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('appontmentNumber')) or (colPickMode==1 and !data.containsKey('appontmentNumber'))">
                a.appontmentNumber=#{data.appontmentNumber},
            </if>
            <if test="(colPickMode==0 and data.containsKey('appointmentStartTime')) or (colPickMode==1 and !data.containsKey('appointmentStartTime'))">
                a.appointmentStartTime=#{data.appointmentStartTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('appointmentEndTime')) or (colPickMode==1 and !data.containsKey('appointmentEndTime'))">
                a.appointmentEndTime=#{data.appointmentEndTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserId')) or (colPickMode==1 and !data.containsKey('createUserId'))">
                a.createUserId=#{data.createUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserIdIncrement')) or (colPickMode==1 and !data.containsKey('createUserIdIncrement'))">
                a.createUserId=ifnull(a.createUserId,0) + #{data.createUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserId')) or (colPickMode==1 and !data.containsKey('updateUserId'))">
                a.updateUserId=#{data.updateUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !data.containsKey('updateUserIdIncrement'))">
                a.updateUserId=ifnull(a.updateUserId,0) + #{data.updateUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_appointment_person as a
        <trim prefix="set" suffixOverrides=",">
            <trim prefix="siteId=(case" suffix="ELSE siteId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('siteId')) or (colPickMode==1 and !item.containsKey('siteId'))">
                            when a.id=#{item.id} then #{item.siteId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('siteIdIncrement')) or (colPickMode==1 and !item.containsKey('siteIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.siteId,0) + #{item.siteIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="siteName=(case" suffix="ELSE siteName end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('siteName')) or (colPickMode==1 and !item.containsKey('siteName'))">
                        when a.id=#{item.id} then #{item.siteName}
                    </if>
                </foreach>
            </trim>
            <trim prefix="personId=(case" suffix="ELSE personId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('personId')) or (colPickMode==1 and !item.containsKey('personId'))">
                            when a.id=#{item.id} then #{item.personId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('personIdIncrement')) or (colPickMode==1 and !item.containsKey('personIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.personId,0) + #{item.personIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="name=(case" suffix="ELSE name end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('name')) or (colPickMode==1 and !item.containsKey('name'))">
                        when a.id=#{item.id} then #{item.name}
                    </if>
                </foreach>
            </trim>
            <trim prefix="contactInfo=(case" suffix="ELSE contactInfo end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('contactInfo')) or (colPickMode==1 and !item.containsKey('contactInfo'))">
                        when a.id=#{item.id} then #{item.contactInfo}
                    </if>
                </foreach>
            </trim>
            <trim prefix="idCard=(case" suffix="ELSE idCard end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('idCard')) or (colPickMode==1 and !item.containsKey('idCard'))">
                        when a.id=#{item.id} then #{item.idCard}
                    </if>
                </foreach>
            </trim>
            <trim prefix="bussinessId=(case" suffix="ELSE bussinessId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('bussinessId')) or (colPickMode==1 and !item.containsKey('bussinessId'))">
                            when a.id=#{item.id} then #{item.bussinessId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('bussinessIdIncrement')) or (colPickMode==1 and !item.containsKey('bussinessIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.bussinessId,0) + #{item.bussinessIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="bussinessName=(case" suffix="ELSE bussinessName end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('bussinessName')) or (colPickMode==1 and !item.containsKey('bussinessName'))">
                        when a.id=#{item.id} then #{item.bussinessName}
                    </if>
                </foreach>
            </trim>
            <trim prefix="appontmentNumber=(case" suffix="ELSE appontmentNumber end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('appontmentNumber')) or (colPickMode==1 and !item.containsKey('appontmentNumber'))">
                        when a.id=#{item.id} then #{item.appontmentNumber}
                    </if>
                </foreach>
            </trim>
            <trim prefix="appointmentStartTime=(case" suffix="ELSE appointmentStartTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('appointmentStartTime')) or (colPickMode==1 and !item.containsKey('appointmentStartTime'))">
                        when a.id=#{item.id} then #{item.appointmentStartTime}
                    </if>
                </foreach>
            </trim>
            <trim prefix="appointmentEndTime=(case" suffix="ELSE appointmentEndTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('appointmentEndTime')) or (colPickMode==1 and !item.containsKey('appointmentEndTime'))">
                        when a.id=#{item.id} then #{item.appointmentEndTime}
                    </if>
                </foreach>
            </trim>
            <trim prefix="createUserId=(case" suffix="ELSE createUserId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('createUserId')) or (colPickMode==1 and !item.containsKey('createUserId'))">
                            when a.id=#{item.id} then #{item.createUserId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('createUserIdIncrement')) or (colPickMode==1 and !item.containsKey('createUserIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.createUserId,0) + #{item.createUserIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                        when a.id=#{item.id} then #{item.createTime}
                    </if>
                </foreach>
            </trim>
            <trim prefix="updateUserId=(case" suffix="ELSE updateUserId end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <choose>
                        <when test="(colPickMode==0 and item.containsKey('updateUserId')) or (colPickMode==1 and !item.containsKey('updateUserId'))">
                            when a.id=#{item.id} then #{item.updateUserId}
                        </when>
                        <when test="(colPickMode==0 and item.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !item.containsKey('updateUserIdIncrement'))">
                            when a.id=#{item.id} then ifnull(a.updateUserId,0) + #{item.updateUserIdIncrement}
                        </when>
                    </choose>
                </foreach>
            </trim>
            <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                <foreach collection="data.dataList" item="item" index="index" separator="" >
                    <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                        when a.id=#{item.id} then #{item.updateTime}
                    </if>
                </foreach>
            </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="AppointmentPersonEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_appointment_person as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_appointment_person as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_appointment_person where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_appointment_person where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_appointment_person where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_appointment_person as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="AppointmentPersonEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_appointment_person as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_appointment_person as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null ">
                ${_conditionType_} a.id = #{${_conditionParam_}.id}
            </if>
            <if test="conditionParamRef.id == null">
                ${_conditionType_} a.id is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('idList') and conditionParamRef.idList.size() > 0">
            ${_conditionType_} a.id in
            <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('idNotList') and conditionParamRef.idNotList.size() > 0">
            ${_conditionType_} a.id not in
            <foreach collection="conditionParamRef.idNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
            ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
        </if>
        <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
            ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
        </if>

        <if test="conditionParamRef.containsKey('siteId')">
            <if test="conditionParamRef.siteId != null ">
                ${_conditionType_} a.siteId = #{${_conditionParam_}.siteId}
            </if>
            <if test="conditionParamRef.siteId == null">
                ${_conditionType_} a.siteId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('siteIdList') and conditionParamRef.siteIdList.size() > 0">
            ${_conditionType_} a.siteId in
            <foreach collection="conditionParamRef.siteIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('siteIdNotList') and conditionParamRef.siteIdNotList.size() > 0">
            ${_conditionType_} a.siteId not in
            <foreach collection="conditionParamRef.siteIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('siteIdStart') and conditionParamRef.siteIdStart != null">
            ${_conditionType_} a.siteId <![CDATA[ >= ]]> #{${_conditionParam_}.siteIdStart}
        </if>
        <if test="conditionParamRef.containsKey('siteIdEnd') and conditionParamRef.siteIdEnd != null">
            ${_conditionType_} a.siteId <![CDATA[ <= ]]> #{${_conditionParam_}.siteIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('siteName')">
            <if test="conditionParamRef.siteName != null and conditionParamRef.siteName != ''">
                ${_conditionType_} a.siteName like #{${_conditionParam_}.siteName}
            </if>
            <if test="conditionParamRef.siteName == null">
                ${_conditionType_} a.siteName is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('siteNameList') and conditionParamRef.siteNameList.size() > 0">
            ${_conditionType_} a.siteName in
            <foreach collection="conditionParamRef.siteNameList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('siteNameNotList') and conditionParamRef.siteNameNotList.size() > 0">
            ${_conditionType_} a.siteName not in
            <foreach collection="conditionParamRef.siteNameNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('personId')">
            <if test="conditionParamRef.personId != null ">
                ${_conditionType_} a.personId = #{${_conditionParam_}.personId}
            </if>
            <if test="conditionParamRef.personId == null">
                ${_conditionType_} a.personId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('personIdList') and conditionParamRef.personIdList.size() > 0">
            ${_conditionType_} a.personId in
            <foreach collection="conditionParamRef.personIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('personIdNotList') and conditionParamRef.personIdNotList.size() > 0">
            ${_conditionType_} a.personId not in
            <foreach collection="conditionParamRef.personIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('personIdStart') and conditionParamRef.personIdStart != null">
            ${_conditionType_} a.personId <![CDATA[ >= ]]> #{${_conditionParam_}.personIdStart}
        </if>
        <if test="conditionParamRef.containsKey('personIdEnd') and conditionParamRef.personIdEnd != null">
            ${_conditionType_} a.personId <![CDATA[ <= ]]> #{${_conditionParam_}.personIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('name')">
            <if test="conditionParamRef.name != null and conditionParamRef.name != ''">
                ${_conditionType_} a.name like #{${_conditionParam_}.name}
            </if>
            <if test="conditionParamRef.name == null">
                ${_conditionType_} a.name is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('nameList') and conditionParamRef.nameList.size() > 0">
            ${_conditionType_} a.name in
            <foreach collection="conditionParamRef.nameList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('nameNotList') and conditionParamRef.nameNotList.size() > 0">
            ${_conditionType_} a.name not in
            <foreach collection="conditionParamRef.nameNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('contactInfo')">
            <if test="conditionParamRef.contactInfo != null and conditionParamRef.contactInfo != ''">
                ${_conditionType_} a.contactInfo like #{${_conditionParam_}.contactInfo}
            </if>
            <if test="conditionParamRef.contactInfo == null">
                ${_conditionType_} a.contactInfo is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('contactInfoList') and conditionParamRef.contactInfoList.size() > 0">
            ${_conditionType_} a.contactInfo in
            <foreach collection="conditionParamRef.contactInfoList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('contactInfoNotList') and conditionParamRef.contactInfoNotList.size() > 0">
            ${_conditionType_} a.contactInfo not in
            <foreach collection="conditionParamRef.contactInfoNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('idCard')">
            <if test="conditionParamRef.idCard != null and conditionParamRef.idCard != ''">
                ${_conditionType_} a.idCard like #{${_conditionParam_}.idCard}
            </if>
            <if test="conditionParamRef.idCard == null">
                ${_conditionType_} a.idCard is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('idCardList') and conditionParamRef.idCardList.size() > 0">
            ${_conditionType_} a.idCard in
            <foreach collection="conditionParamRef.idCardList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('idCardNotList') and conditionParamRef.idCardNotList.size() > 0">
            ${_conditionType_} a.idCard not in
            <foreach collection="conditionParamRef.idCardNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('bussinessId')">
            <if test="conditionParamRef.bussinessId != null ">
                ${_conditionType_} a.bussinessId = #{${_conditionParam_}.bussinessId}
            </if>
            <if test="conditionParamRef.bussinessId == null">
                ${_conditionType_} a.bussinessId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('bussinessIdList') and conditionParamRef.bussinessIdList.size() > 0">
            ${_conditionType_} a.bussinessId in
            <foreach collection="conditionParamRef.bussinessIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('bussinessIdNotList') and conditionParamRef.bussinessIdNotList.size() > 0">
            ${_conditionType_} a.bussinessId not in
            <foreach collection="conditionParamRef.bussinessIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('bussinessIdStart') and conditionParamRef.bussinessIdStart != null">
            ${_conditionType_} a.bussinessId <![CDATA[ >= ]]> #{${_conditionParam_}.bussinessIdStart}
        </if>
        <if test="conditionParamRef.containsKey('bussinessIdEnd') and conditionParamRef.bussinessIdEnd != null">
            ${_conditionType_} a.bussinessId <![CDATA[ <= ]]> #{${_conditionParam_}.bussinessIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('bussinessName')">
            <if test="conditionParamRef.bussinessName != null and conditionParamRef.bussinessName != ''">
                ${_conditionType_} a.bussinessName like #{${_conditionParam_}.bussinessName}
            </if>
            <if test="conditionParamRef.bussinessName == null">
                ${_conditionType_} a.bussinessName is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('bussinessNameList') and conditionParamRef.bussinessNameList.size() > 0">
            ${_conditionType_} a.bussinessName in
            <foreach collection="conditionParamRef.bussinessNameList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('bussinessNameNotList') and conditionParamRef.bussinessNameNotList.size() > 0">
            ${_conditionType_} a.bussinessName not in
            <foreach collection="conditionParamRef.bussinessNameNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('appontmentNumber')">
            <if test="conditionParamRef.appontmentNumber != null and conditionParamRef.appontmentNumber != ''">
                ${_conditionType_} a.appontmentNumber like #{${_conditionParam_}.appontmentNumber}
            </if>
            <if test="conditionParamRef.appontmentNumber == null">
                ${_conditionType_} a.appontmentNumber is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('appontmentNumberList') and conditionParamRef.appontmentNumberList.size() > 0">
            ${_conditionType_} a.appontmentNumber in
            <foreach collection="conditionParamRef.appontmentNumberList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('appontmentNumberNotList') and conditionParamRef.appontmentNumberNotList.size() > 0">
            ${_conditionType_} a.appontmentNumber not in
            <foreach collection="conditionParamRef.appontmentNumberNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>

        <if test="conditionParamRef.containsKey('appointmentStartTime')">
            <if test="conditionParamRef.appointmentStartTime != null ">
                ${_conditionType_} a.appointmentStartTime = #{${_conditionParam_}.appointmentStartTime}
            </if>
            <if test="conditionParamRef.appointmentStartTime == null">
                ${_conditionType_} a.appointmentStartTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('appointmentStartTimeStart') and conditionParamRef.appointmentStartTimeStart != null and conditionParamRef.appointmentStartTimeStart!=''">
            ${_conditionType_} a.appointmentStartTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.appointmentStartTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('appointmentStartTimeEnd') and conditionParamRef.appointmentStartTimeEnd != null and conditionParamRef.appointmentStartTimeEnd!=''">
            ${_conditionType_} a.appointmentStartTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.appointmentStartTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>

        <if test="conditionParamRef.containsKey('appointmentEndTime')">
            <if test="conditionParamRef.appointmentEndTime != null ">
                ${_conditionType_} a.appointmentEndTime = #{${_conditionParam_}.appointmentEndTime}
            </if>
            <if test="conditionParamRef.appointmentEndTime == null">
                ${_conditionType_} a.appointmentEndTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('appointmentEndTimeStart') and conditionParamRef.appointmentEndTimeStart != null and conditionParamRef.appointmentEndTimeStart!=''">
            ${_conditionType_} a.appointmentEndTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.appointmentEndTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('appointmentEndTimeEnd') and conditionParamRef.appointmentEndTimeEnd != null and conditionParamRef.appointmentEndTimeEnd!=''">
            ${_conditionType_} a.appointmentEndTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.appointmentEndTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('createUserId')">
            <if test="conditionParamRef.createUserId != null ">
                ${_conditionType_} a.createUserId = #{${_conditionParam_}.createUserId}
            </if>
            <if test="conditionParamRef.createUserId == null">
                ${_conditionType_} a.createUserId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('createUserIdList') and conditionParamRef.createUserIdList.size() > 0">
            ${_conditionType_} a.createUserId in
            <foreach collection="conditionParamRef.createUserIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('createUserIdNotList') and conditionParamRef.createUserIdNotList.size() > 0">
            ${_conditionType_} a.createUserId not in
            <foreach collection="conditionParamRef.createUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('createUserIdStart') and conditionParamRef.createUserIdStart != null">
            ${_conditionType_} a.createUserId <![CDATA[ >= ]]> #{${_conditionParam_}.createUserIdStart}
        </if>
        <if test="conditionParamRef.containsKey('createUserIdEnd') and conditionParamRef.createUserIdEnd != null">
            ${_conditionType_} a.createUserId <![CDATA[ <= ]]> #{${_conditionParam_}.createUserIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('createTime')">
            <if test="conditionParamRef.createTime != null ">
                ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
            </if>
            <if test="conditionParamRef.createTime == null">
                ${_conditionType_} a.createTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
            ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
            ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('updateUserId')">
            <if test="conditionParamRef.updateUserId != null ">
                ${_conditionType_} a.updateUserId = #{${_conditionParam_}.updateUserId}
            </if>
            <if test="conditionParamRef.updateUserId == null">
                ${_conditionType_} a.updateUserId is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdList') and conditionParamRef.updateUserIdList.size() > 0">
            ${_conditionType_} a.updateUserId in
            <foreach collection="conditionParamRef.updateUserIdList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdNotList') and conditionParamRef.updateUserIdNotList.size() > 0">
            ${_conditionType_} a.updateUserId not in
            <foreach collection="conditionParamRef.updateUserIdNotList" open="(" close=")" index="index" item="item" separator=",">
                #{item}
            </foreach>
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdStart') and conditionParamRef.updateUserIdStart != null">
            ${_conditionType_} a.updateUserId <![CDATA[ >= ]]> #{${_conditionParam_}.updateUserIdStart}
        </if>
        <if test="conditionParamRef.containsKey('updateUserIdEnd') and conditionParamRef.updateUserIdEnd != null">
            ${_conditionType_} a.updateUserId <![CDATA[ <= ]]> #{${_conditionParam_}.updateUserIdEnd}
        </if>


        <if test="conditionParamRef.containsKey('updateTime')">
            <if test="conditionParamRef.updateTime != null ">
                ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
            </if>
            <if test="conditionParamRef.updateTime == null">
                ${_conditionType_} a.updateTime is null
            </if>
        </if>
        <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
            ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
        </if>
        <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
            ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
        </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                    ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <if test="orderCol.containsKey('id')">
                    a.id
                    <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('siteId')">
                    a.siteId
                    <if test='orderCol.siteId != null and "DESC".equalsIgnoreCase(orderCol.siteId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('siteName')">
                    a.siteName
                    <if test='orderCol.siteName != null and "DESC".equalsIgnoreCase(orderCol.siteName)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('personId')">
                    a.personId
                    <if test='orderCol.personId != null and "DESC".equalsIgnoreCase(orderCol.personId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('name')">
                    a.name
                    <if test='orderCol.name != null and "DESC".equalsIgnoreCase(orderCol.name)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('contactInfo')">
                    a.contactInfo
                    <if test='orderCol.contactInfo != null and "DESC".equalsIgnoreCase(orderCol.contactInfo)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('idCard')">
                    a.idCard
                    <if test='orderCol.idCard != null and "DESC".equalsIgnoreCase(orderCol.idCard)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('bussinessId')">
                    a.bussinessId
                    <if test='orderCol.bussinessId != null and "DESC".equalsIgnoreCase(orderCol.bussinessId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('bussinessName')">
                    a.bussinessName
                    <if test='orderCol.bussinessName != null and "DESC".equalsIgnoreCase(orderCol.bussinessName)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('appontmentNumber')">
                    a.appontmentNumber
                    <if test='orderCol.appontmentNumber != null and "DESC".equalsIgnoreCase(orderCol.appontmentNumber)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('appointmentStartTime')">
                    a.appointmentStartTime
                    <if test='orderCol.appointmentStartTime != null and "DESC".equalsIgnoreCase(orderCol.appointmentStartTime)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('appointmentEndTime')">
                    a.appointmentEndTime
                    <if test='orderCol.appointmentEndTime != null and "DESC".equalsIgnoreCase(orderCol.appointmentEndTime)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('createUserId')">
                    a.createUserId
                    <if test='orderCol.createUserId != null and "DESC".equalsIgnoreCase(orderCol.createUserId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('createTime')">
                    a.createTime
                    <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('updateUserId')">
                    a.updateUserId
                    <if test='orderCol.updateUserId != null and "DESC".equalsIgnoreCase(orderCol.updateUserId)'>DESC</if>
                    ,
                </if>
                <if test="orderCol.containsKey('updateTime')">
                    a.updateTime
                    <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                    ,
                </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>